<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<app-role-checker [allowedRoles]="[admin, nodeOperator]" class="h-full w-full flex flex-col">
  <ng-template let-authorized>
    <div *ngIf="selectable" class="w-full border-b border-borderGrey pb-4 mt-1 text-sm text-text-300 flex items-center">
      <div class="grow flex items-center px-3 h-[36px]">
        <p-checkbox
          *ngIf="selectable"
          [(ngModel)]="allSelected"
          inputId="select-all"
          [binary]="true"
          (onChange)="toggleAll()"
        ></p-checkbox>
        <label *ngIf="selectable" for="select-all" class="cursor-pointer pl-4">Select all</label>
        <div *ngIf="selectionAction" class="ml-2 grow">
          <ng-template [ngTemplateOutlet]="selectionAction"></ng-template>
        </div>
      </div>
    </div>
    <div
      *ngIf="contractIdentities.length <= 0"
      class="w-full grow flex flex-col items-center gap-4 py-2 justify-center"
    >
      <div class="text-lg font-semibold text-text-300">
        <app-sad-face></app-sad-face>
      </div>
      <div class="text-text-300">{{ emptyMessage }}</div>
    </div>
    <cdk-virtual-scroll-viewport
      #virtualScroller
      *ngIf="contractIdentities.length > 0"
      class="grow w-full"
      [itemSize]="itemSize"
      (scrolledIndexChange)="scrollhandler($event)"
      [ngStyle]="{ height: containerHeight + 'px' }"
    >
      <div
        class="w-full h-full overflow-y-auto [&>*:nth-child(even)]:bg-whitesmoke [&>*:nth-child(even)]:bg-opacity-40"
      >
        <div *cdkVirtualFor="let identity of contractIdentities" class="flex items-center border-b border-borderGrey">
          <ng-container *ngLet="$any(identity.targetStatus | async) as targetStatus">
            <ng-container *ngLet="$any(identity.assigneeStatus | async) as assigneeStatus">
              <ng-container *ngLet="$any(identity.assignerStatus | async) as assignerStatus">
                <ng-container *ngLet="$any(identity.contract) as contract">
                  <ng-container *ngIf="contract">
                    <div class="w-[400px] p-3">
                      <div class="py-4 flex items-center gap-4">
                        <p-checkbox
                          *ngIf="selectable"
                          inputId="select-contract"
                          [value]="contract.policyId"
                          [(ngModel)]="selectedItems"
                          (onChange)="toggleOne()"
                        ></p-checkbox>
                        <app-contract-preview
                          [contract]="contract"
                          [loadingTarget]="loadingIdentity(targetStatus)"
                          [loadingAssignee]="loadingIdentity(assigneeStatus)"
                          [loadingAssigner]="loadingIdentity(assignerStatus)"
                        ></app-contract-preview>
                      </div>
                    </div>
                    <div class="w-[260px]">
                      <app-contract-status [contract]="contract"></app-contract-status>
                    </div>
                    <div>
                      <ng-template
                        *ngIf="authorized && options"
                        [ngTemplateOutlet]="options"
                        [ngTemplateOutletContext]="{ $implicit: contract }"
                      ></ng-template>
                    </div>
                  </ng-container>
                </ng-container>
              </ng-container>
            </ng-container>
          </ng-container>
        </div>
      </div>
    </cdk-virtual-scroll-viewport>
  </ng-template>
</app-role-checker>
